/**********************************************************/
/*    filename:cci_tbl.c L\                       */
/**********************************************************/
#include "cci.h"
#include "cci_prot.h"

/* ----------------------------e[u */
#define TBL_MAX    1000      /* L\̃TCY   */
#define start_GTBL 1         /* p̊Jnʒu */
#define LTBL_EMPTY 9999      /* ǏL\   */
SymTbl table[TBL_MAX+1];     /* L\           */
int start_LTBL = LTBL_EMPTY; /* Ǐp̊Jnʒu */
int tableCt = 0;             /* gp̍ŏIʒu */

SymTbl *enter(SymTbl tb, SymKind kind) /* L\o^ */
{
  int tbNo;

  if ((kind==varId || kind==paraId) && tb.dtTyp==VOID_T) {
    err_s("ϐ^(void)");
    tb.dtTyp = INT_T;                                            /* intɂ */
  }
  tb.nmKind = kind;
  nameChk(tb);                                       /* ƕϐ̏dchk */

  if (tableCt >= TBL_MAX) { err_s("L\ over"); exit(1); }
  tbNo = ++tableCt;                                             /* L\ԍ */
  table[tbNo] = tb;                                           /* L\ɓo^ */

  if (kind == paraId) ++table[tbNo].level;  /* ֐ubNɓ钲 */
  if (kind == varId) set_adrs(&table[tbNo]);          /* ϐȂAhXݒ */
  if (kind == fncId) table[tbNo].adrs = -tbNo;    /* L\ԍ̕l֐ */
                                          /* ԒnƂĉݒ(Ԓn̈) */
  return &table[tbNo];                                /* L\|C^Ԃ */
}

void localTBL_open(void) /* ǏL\Jn */
{
  start_LTBL = tableCt + 1;                     /* ǏpL\Jnʒuݒ */
}

void localTBL_close(SymTbl *fp) /* ǏL\I */
{                         /* o^̈Ɏc߈ */
  tableCt = start_LTBL - 1 + fp->args;                  /* pŏIʒu */
  start_LTBL = LTBL_EMPTY;                                /* ǏL\NA */
}

SymTbl *search(char *s) /* L\(T[rX) */
{
  SymTbl *p;
  static SymTbl *dmy_p=NULL, wkTb = {"tmp$name2",varId,INT_T,0,0,0,0};

  p = search_name(s);
  if (p == NULL) {                                    /* ȂΉϐԂ */
    err_ss("`̎ʎq", s);
    if (dmy_p == NULL) dmy_p = enter(wkTb, varId);              /* ϐo^ */
    p = dmy_p;
  }
  return p;
}

SymTbl *search_name(char *s) /* L\ */
{
  int i;                         /* :ǏL\ȂƂstart_LTBL9999 */
  for (i=tableCt; i>=start_LTBL; i--) {                 /* ɋǏ̈T */
    if (strcmp(table[i].name,s)==0) return table + i;
  }
  for (; i>=start_GTBL; i--) {                          /* ɑ̈T */
    if (table[i].nmKind!=paraId && strcmp(table[i].name,s)==0)
      return table + i;
  }
  return NULL;                                                    /* Ȃ */
}

void nameChk(SymTbl tb) /* ƕϐ̖Od`FbN */
{
  SymTbl *p;
  extern int blkNest;                                         /* (cci_pars.c) */
  int nest = blkNest;

  if (tb.nmKind!=paraId && tb.nmKind!=varId) return;
  if ((p = search_name(tb.name)) == NULL) return;
  if (tb.nmKind == paraId) ++nest;                  /* pɋL撲 */
  if (p->level >= nest) err_ss("ʎqdĂ", tb.name);
}

void del_fncTable(SymTbl *f1, SymTbl *f2) /* do^̉ */
{
  int i;
  if (f1 == NULL) return;
  if (f1->dtTyp!=f2->dtTyp || f1->args!=f2->args)  return;
  if (f1->nmKind==protId && f2->nmKind==fncId) {  /* f1vgAf2{̂Ȃ */
    for (i=0; i<=f2->args; i++) { *(f1+i) = *(f2+i); }      /* f2f1ɃRs[ */
  }
  tableCt -= (f2->args + 1);                              /* Vo^ */
  return;
}

int b_flg(SymTbl *tp) /* ǏϐȂ1Ԃ */
{
  if (tp->level == 0) return 0; else return 1;                   /* Ȃ0 */
}

SymTbl *tb_ptr(int n) /* L\AhXԂ */
{
  return &table[n];
}
